﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using Common;

namespace MvcApplication2.Controllers
{
    public class BaseController : Controller
    {
        protected SessionHelper session = new SessionHelper();

        public BaseController()
        {
            
        }
         /// <summary>
        /// 异常处理
         /// </summary>
         /// <param name="filterContext"></param>
        protected override void OnException(ExceptionContext filterContext)
        {
            if (filterContext.HttpContext.Request.IsAjaxRequest())
            {
                JsonResult result = new JsonResult();
                result.Data = new { type = "error", data = "请求异常" };
                filterContext.Result = result;
            }
            else
            {
                filterContext.Result = new RedirectResult("~/error/index");
            }
            filterContext.ExceptionHandled = true;
            base.OnException(filterContext);
        }
    }
}
