﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Web.Http;
using MvcWebApi.Models;
using Common;
using System.Data;

namespace MvcWebApi.Controllers
{
    public class ValuesController : ApiController
    {
        SessionHelper session = new SessionHelper();
        RedisHelper Redise = new RedisHelper();
        // GET api/values

        public HttpResponseMessage Get()
        {
            //判断session的值是否传递过来
            if (session["user"] == null)
            {
                return Request.CreateResponse(HttpStatusCode.OK, new { type="error",data="session为空，清先登陆"});
            }
            var stuList = Redise.GetList<Students>("stuList");
            if (stuList == null || stuList.Count()==0)
            {
                using (DbHelper db = new DbHelper())
                {
                    stuList = db.Students.ToList();
                    //创建stuList缓存链表
                    Redise.AddList<Students>("stuList", stuList);
                }
            }
            var data = new { type = "success", data = stuList };
            return Request.CreateResponse(HttpStatusCode.OK, data); //db.Students.ToList();
            
        }

        // GET api/values/5
        public Students Get(string id)
        {
            Students stu = Redise.GetList<Students>("stuList").Where(it => it.Num == id).FirstOrDefault();
            if (stu == null)
            {
                using (DbHelper db = new DbHelper())
                {
                    stu=db.Students.Where(it => it.Num == id).FirstOrDefault();
                    if (stu != null)
                    {
                        //向stuList缓存链表中添加实体
                        Redise.AddEntityToList<Students>("stuList", stu);
                    }
                }
            }
            return stu;
        }

        // POST api/values
        public void  Post([FromBody] Students stu)
        {
           
        }

        // PUT api/values/5
        public HttpResponseMessage Put([FromBody] Students stu)
        {
            Students RedStu = Redise.GetList<Students>("stuList").Where(it => it.Num == stu.Num).FirstOrDefault();

            Redise.RemoveEntityFromList<Students>("stuList", RedStu);
            Redise.AddEntityToList("stuList", stu);
            using (DbHelper db = new DbHelper())
            {
                db.Entry(stu).State = EntityState.Modified;
                db.SaveChanges();
            }

            return Request.CreateResponse(HttpStatusCode.OK, new { type = "success" });
        }

        // DELETE api/values/5
        public void Delete(int id)
        {
        }
    }
    
}